/*
 */

#include "EXTERN.h"
#include "perl.h"

#include <stdio.h>
#include <errno.h>
#include <dos.h>
#include <time.h>
#include <signal.h>

int
ioctl(int handle, unsigned int function, char *data)
{
	union REGS      srv;
	struct SREGS    segregs;

	srv.h.ah = 0x44;
	srv.h.al = (unsigned char)(function & 0x0F);
	srv.x.bx = handle;
	srv.x.cx = function >> 4;
#if ( defined(M_I86LM) || defined(M_I86CM) || defined(M_I86HM) )
	segregs.ds = FP_SEG(data);
	srv.x.dx = FP_OFF(data);
#else
	srv.x.dx = (unsigned int) data;
#endif
	intdosx(&srv, &srv, &segregs);
	if (srv.x.cflag & 1) {
		switch(srv.x.ax ){
		case 1:
			errno = EINVAL;
			break;
		case 2:
		case 3:
			errno = ENOENT;
			break;
		case 4:
			errno = EMFILE;
			break;
		case 5:
			errno = EPERM;
			break;
		case 6:
			errno = EBADF;
			break;
		case 8:
			errno = ENOMEM;
			break;
		case 0xc:
		case 0xd:
		case 0xf:
			errno = EINVAL;
			break;
		case 0x11:
			errno = EXDEV;
			break;
		case 0x12:
			errno = ENFILE;
			break;
		default:
			errno = 0;
			break;
		}
		return -1;
	} else {
		switch (function & 0xf) {
		case 0: case 9: case 0xa:
			return srv.x.dx;
		case 2: case 3: case 4: case 5:
		case 6: case 7: case 8: case 0xe:
			return srv.x.ax;
		case 1: case 0xb: case 0xc: case 0xd:
		case 0xf:
		default:
			return 0;
		}
	}
}

/*
 * Just pretend that everyone is a superuser
 */
#define ROOT_UID	0
#define ROOT_GID	0
int
getuid(void)
{
	return ROOT_UID;
}

int
geteuid(void)
{
	return ROOT_UID;
}

int
getgid(void)
{
	return ROOT_GID;
}

int
getegid(void)
{
	return ROOT_GID;
}

int
setuid(int uid)
{
    return (uid==ROOT_UID?0:-1);
}

int
setgid(int gid)
{
    return (gid==ROOT_GID?0:-1);
}

int
do_aspawn(really,arglast)
STR *really;
int *arglast;
{
    register STR **st = stack->ary_array;
    register int sp = arglast[1];
    register int items = arglast[2] - sp;
    register char **a;
    char *p;
    char *arg;
    int   sl, argl, argf;
    char *tmps;
    int status = -1;

    if (items) {
	argl = 512;
	argf = 512;
	New(1101,arg, argl, char);
	st += ++sp;
	if (really && *(tmps = str_get(really))) {
	    strcpy(arg, tmps);
	    argf -= strlen(tmps) + 1;
	} else {
	    p = str_get(*st);
	    strcpy(arg, p);
	    argf -= strlen(p) + 1;
	}
	items--;
	st++;
	for (; items > 0; items--,st++) {
	    if (*st) {
		p = str_get(*st);
		sl = strlen(p);
		if (sl >= argf - 2) {
		    argl += 512;
    		    argf += 512;
		    Renew(arg, argl, char);
		}
		strcat(arg, " ");
		strcat(arg, p);
		argf -= sl + 1;
	    }
	}
	Safefree(arg);
    }
    status = system(arg);
    return status >= 0 ? (status << 8) & 0xFF00 : status;
}


int
do_spawn(cmd)
char *cmd;
{
    return system(cmd);
}

void
sigcatch(sig,cod)
int sig, cod;
{
	if (sig == SIGFPE) {
		fprintf(stderr, "floating point exception.\n");
		exit(1);
	} else if (sig == SIGINT) {
		exit(1);
	} else {
	/* cannot happen... */
		exit(1);
	}
}

#define u_char unsigned char

static u_char charmap[] = {
	'\000', '\001', '\002', '\003', '\004', '\005', '\006', '\007',
	'\010', '\011', '\012', '\013', '\014', '\015', '\016', '\017',
	'\020', '\021', '\022', '\023', '\024', '\025', '\026', '\027',
	'\030', '\031', '\032', '\033', '\034', '\035', '\036', '\037',
	'\040', '\041', '\042', '\043', '\044', '\045', '\046', '\047',
	'\050', '\051', '\052', '\053', '\054', '\055', '\056', '\057',
	'\060', '\061', '\062', '\063', '\064', '\065', '\066', '\067',
	'\070', '\071', '\072', '\073', '\074', '\075', '\076', '\077',
	'\100', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
	'\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
	'\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
	'\170', '\171', '\172', '\133', '\134', '\135', '\136', '\137',
	'\140', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
	'\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
	'\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
	'\170', '\171', '\172', '\173', '\174', '\175', '\176', '\177',
	'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
	'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
	'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
	'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
	'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
	'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
	'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
	'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
#ifdef KANJI
	'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
	'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
	'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
	'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\333',
#else
	'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
	'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
	'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\327',
	'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\337',
#endif
	'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
	'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
	'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
	'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

int
stricmp(s1, s2)
	const char *s1, *s2;
{
	register u_char	*cm = charmap,
			*us1 = (u_char *)s1,
			*us2 = (u_char *)s2;

	while (cm[*us1] == cm[*us2++])
#ifdef KANJI
	{
	    if (*us1++ == '\0')
		return(0);
	    if (iskanji(us1[-1]) && us1[0]) {
		if (*us1 != *us2)
		    return *us1 - *us2;
		++us1;
		++us2;
	    }
	}
#else
		if (*us1++ == '\0')
			return(0);
#endif
	return(cm[*us1] - cm[*--us2]);
}

int
strnicmp(s1, s2, n)
	const char *s1, *s2;
	register size_t n;
{
	register u_char	*cm = charmap,
			*us1 = (u_char *)s1,
			*us2 = (u_char *)s2;
	long nn = (long) n;

	while (--nn >= 0 && cm[*us1] == cm[*us2++])
#ifdef KANJI
	{
	    if (*us1++ == '\0')
		return (0);
	    if (iskanji(us1[-1]) && us1[0] && nn > 0) {
		if (*us1 != *us2)
		    return *us1 - *us2;
		++us1;
		++us2;
		--nn;
	    }
	}
#else
		if (*us1++ == '\0')
			return(0);
#endif
	return(nn < 0 ? 0 : cm[*us1] - cm[*--us2]);
}
